//*****************************************************************
//	新説？！ 桃太郎ゲーム
//		Ｉ／Ｏ別冊　ＭＺ活用研究よりの移植
//  Ａｒｒａｎｇｅｄ　１９９０－９２,９４,９９　ｂｙ　ＡＩＧ－ＳＯＦＴ
//*****************************************************************
// V3.20 later

// iPadのみ
if not checkCompatible(COMPATIBLE_IPAD) then stop

width(0)
int gwx,gwy
getWidth(gwx,gwy):// グラフィックモードで画面幅を取得 / Get screen width by graphics mode

// 定数定義
enum
	WX		=48		:// 画面幅 Ｘ
	WY		=31		:// 画面幅 Ｙ
	SCMOMO	=50		:// 桃の得点
	SCSAKE	=100	:// 酒の得点
	SCEDA	=30		:// 枝の減点
	SCHUNE	=150	:// 舟の減点
	WKAWA	=19		:// 川の行数－１
	TLIMIT	=(60*2)	:// 秒単位で設定：今は２分

	// キャラクターの内部コード
	SPACE   =' '
	MOMO	='@'	:// 下流の桃
	MOMO2	='&'	:// 中流の桃
	MOMO1	='.'	:// 上流の桃
	TMOMO	='*'	:// つぶれた桃等
	HITO	='a'	:// 人
	KHITO	='b'	:// こけた人
	MHITO	='c'	:// 桃等を持った人
	EDA		='-'	:// 枝
	HUNE	='+'	:// 舟
	SAKE	='?'	:// 酒
	KISI	='#'	:// 岸＝桃等を置く場所
	// キーコード
	KLEFT=	'4'
	KRIGHT=	'6'
	EXITKEY='!'

	// 画面幅
	FNTSZ=	24	:// フォントサイズ
endenum

str RECHIGH="MOMO.HSC"	:// ハイ・スコア ファイル名

//*****************************************************************
// グローバル変数

int	manx,many,mm		:// 人
int	hito				:// 人の状態
int	motimono			:// 持ち物
int	sc,hsc,wsc			:// 得点
int	fload=0				:// 得点記録を読み出したかどうか
dim int	mx(WY),my(WY)	:// 桃の座標
dim int	momo(WY)		:// 桃と思っている物の実態
int	jouryuu,chuuryuu,karyuu:// 上流・中流・下流の行数
int	tm,stime			:// 初期時間、経過時間

//*****************************************************************
// 仮想VRAM / Virtual VRAM
dim char tvram(WX,WY)

//*****************************************************************
//
dim int	touchNo(10)	:// タッチエリア番号 / touch area number
int touchallcnt =0	:// タッチエリア数   / the number of touch area

//****************************************************************
// 画面初期設定

font("Migu-1M-Regular",FNTSZ):// 先にフォントを設定してからwidth()を設定する
int fzenhan
width(WX,,fzenhan)
int xw=1:// 全角１文字の桁数 / zenkaku 1 character columus
if fzenhan then xw=2
//
int wx,wy
float fntWx,fntWy
getWidth(wx,wy,,fntWx,fntWy)
//print "wx=";wx;"/wy=";wy;"/fntWx=";fntWx;"/fntWy=";fntWy
int gcx=(gwx-WX*16)/2
int gcy=(fntWy*3)
//
vpriority(TPAGE,GPAGE0,GPAGE1,GPAGE2,GPAGE3)
vpage(B_TPAGE+B_GPAGE0+B_GPAGE1)
apage(GPAGE0):bitmapOpen(0,0,YES):bitmapWipe()
//tborder(1,CTHCYAN)
beep2(13,YES)
//setTouchArea(0,0,0,0,0,YES):// これがないと任意のタッチ座標を得られない / Need for getting any touch coordinate

//****************************************************************
// パターンの定義
// 元はフォントパターンなので、このデータ形式である
// スプライトパターンエリアをパターンの記憶領域として使っている

sp_init():// ここでスプライト画面は非表示になる / Hide sprite screen
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,03,80,1f,50,37,a8,7f,d4,6f,d4,6f,d4,6f,d4,77,d4,3f,a8,1f,50",MOMO	)
setSprite("00,00,07,e0,07,e0,07,e0,07,e0,01,80,0f,f0,3f,dc,2f,f4,0f,f0,07,e0,07,e0,0c,30,18,18,30,0c,00,00",MHITO	)
setSprite("00,00,07,e0,07,e0,07,e0,07,e0,01,80,01,80,3f,fc,01,80,01,80,03,c0,06,60,0c,30,18,18,30,0c,00,00",HITO	)
setSprite("00,00,00,00,01,02,01,06,01,0c,79,18,79,30,7f,e0,7f,e0,79,30,79,18,01,0c,01,06,01,02,00,00,00,00",KHITO	)
setSprite("cc,cc,cc,cc,33,33,33,33,cc,cc,cc,cc,33,33,33,33,cc,cc,cc,cc,33,33,33,33,cc,cc,cc,cc,33,33,33,33",KISI	)
setSprite("00,80,00,c0,01,a0,02,a0,02,90,02,88,04,88,04,84,04,82,04,82,02,81,02,86,01,98,7e,ef,10,44,0f,f8",HUNE	)
setSprite("00,00,01,e0,01,20,01,e0,01,e0,07,f8,0f,fc,1b,fe,37,ff,2c,07,2b,fb,2b,fb,3b,fb,3c,07,1f,fe,0f,fc",SAKE	)
//
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,60,00,90,00,90,00,60,00",MOMO2):// 。中流の桃
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,60,00,60,00,00,00,00,00",MOMO1):// 上流の桃
setSprite("00,00,00,00,00,00,00,00,01,00,19,30,0d,60,07,c0,01,00,07,c0,0d,60,19,30,01,00,00,00,00,00,00,00",TMOMO):// つぶれた桃等
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,3c,00,43,01,80,c2,00,3c,00,00,00,00,00,00,00,00,00,00,00,00",EDA	 ):// 枝
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00",SPACE):// 8140	// スペース
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,00,ff,ff", '_' ):// 8151	// 風景
setSprite("00,01,00,02,00,04,00,08,00,10,00,20,00,40,00,80,01,00,02,00,04,00,08,00,10,00,20,00,40,00,80,00", '[' ):// 815e	// 山川左
setSprite("80,00,40,00,20,00,10,00,08,00,04,00,02,00,01,00,00,80,00,40,00,20,00,10,00,08,00,04,00,02,00,01", ']' ):// 815f	// 山川右
setSprite("00,00,00,00,00,00,00,00,00,00,00,00,3c,00,43,01,80,c2,00,3c,00,00,00,00,00,00,00,00,00,00,00,00", EDA ):// 8160	// 枝
setSprite("00,00,01,00,03,80,07,c0,0d,60,11,10,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,01,00,00,00", ',' ):// 81aa	// 風景
setSprite("03,80,01,00,09,20,1f,f0,09,20,01,00,03,80,01,00,01,00,03,80,01,00,09,20,1f,f0,09,20,01,00,03,80", '^' ):// 81f6	// 木１
setSprite("01,00,03,80,03,80,01,00,09,20,1f,f0,09,20,01,00,03,80,07,c0,03,80,01,00,01,00,01,00,01,00,01,00", '|' ):// 81f5	// 木２

//*****************************************************************

int ret,ky
int fp
dim int scf(1)

	// 得点記録読みだし
	hsc=-65535
	wsc= 65535
	fp=fopen(RECHIGH,"r")
	if (not fopenError(fp)) then {:// hi-score write
		fread(scf,2,fp)
		hsc=scf(0)
		wsc=scf(1)
		fclose(fp)
		fload=1:// 得点記録を読み出した
	}
	
	repeat
		// 初期化
		init()
		disp_init()
		setKeys((WX-4*3)/2,38)
		
		// スタート
		start()
		kbclr()
		
		// ゲーム本体
		game_main()
		// 終了
		saiten()
		
		// 終了
		dim str menues(1)
		str title$
		if isLocalizeJapan() then {
			title$="もう一度しますか？"
			menues={"はい","いいえ"}
		} else {
			title$="Try again ?"
			menues={"Yes","No"}
		}
		switch selectMenu2(title$,menues)
			case 0
				ky=0
				break
			case 1
				ky=EXITKEY
				break
		endswitch
		removeKeys()
	until ky=EXITKEY
	// bitmapを開放する
	bitmapClose()

	// ハイスコアをファイルを書き出す
	fp=fopen(RECHIGH,"c")
	if (not fopenError(fp)) then {:// hi-score write
		scf(0)=hsc
		scf(1)=wsc
		fwrite(scf,2,fp)
		fclose(fp)
	}
end

//*****************************************************************

func start()
int tim=3
	repeat
		wait(1)
		if isLocalizeJapan() then {
			locate((WX-11)/2,15)
			print using "開始 # 秒前",tim
		} else {
			locate((WX-17)/2,15)
			print using "Start CountDown #",tim
		}
		beep()
		tim=tim-1
	until tim=0
	wait(1)
	locate(0,15):print chr$(DISP_CTRL_CLEARLINE);
	if isLocalizeJapan() then {
		locate((WX-8)/2,15):print "開始！！";
	} else {
		locate((WX-8)/2,15):print "Start!!";
	}
	print chr$(DISP_CTRL_CLEARLINE);
	bell(5)
	wait(0.5)
	locate(0,15):print chr$(DISP_CTRL_CLEARLINE);

	tm=time():// スタート時間
	stime=0:// 経過時間＝０
endfunc

//*****************************************************************

func game_main()
// ゲーム本体

int c,i
	repeat
		// 次に出す物は
		setmomo(jouryuu)
		
		// 人を動かす
		move_man(1)
		vwait(3):// ウエイト
		
		// 人がいる所→下流→中流→上流：一気に行う
		for i=0 to WKAWA
			// つぶれた桃等を消す（本当はi=0の時のみ）
			if mm then {
				vwait(12)
				printxy(mx(0),my(0),' ',NO)
				mm=0
			}
			
			if i=WKAWA/2 then {
				// 人を動かす
				move_man(0)
			}
			
			// 桃を動かす
			move_momo(i)
			printxy(mx(i+1),my(i+1),' ',NO):// 元の位置を消す
			
			c=momo(i+1):// 実体の移動
			momo(i)=c
			
			// 下流のときはcそのまま
			if i=0		  then c=attack(c):// 桃取り処理
			if i>karyuu   then c=MOMO2:// 中流
			if i>chuuryuu then c=MOMO1:// 上流
			printxy(mx(i),my(i),c,YES)
		next
		// 人を動かす
		move_man(1)
		vwait(5)
		
		// 時間切れ判定
	until time_print():// 時間切れまで
endfunc

//*****************************************************************

func setmomo(n;int)
// 桃の設定
int c
	if rand2(100)<95 then c=MOMO else c=SAKE:// 桃／酒
	if rand2(100)<50 then { :// 枝／舟
		if rand2(100)<90 then c=EDA else c=HUNE
	}
	momo(n)=c
endfunc

//*****************************************************************

func int attack(c;int)
// 桃取り処理
// リターン値は次に表示するもの
	if scrn(mx(0),my(0))=' ' then { :// 桃の移動先が空間の時
		if c=MOMO or c=SAKE then c=TMOMO:// 受け取らなかった＝桃/酒がつぶれた
		// 枝、舟の時は何もしない
		mm=1:// 次に消す
		return(c)
	}
	
	// 移動先は空間でない＝人がいる
	if c=MOMO or c=SAKE then { :// いいもんみっけ！
		if motimono<>0 then {
			// 既に持っているのにさらに持とうとした時は落としてしまう。
			// 欲張りはだめよ！
			// 減点はない
			hito=HITO
			motimono=0
		} else {
			hito=MHITO
			motimono=c
		}
		bitmapImgLoad()
		beep():vwait(2)
		return(hito)
	}
	// 枝か舟に当たった
	printxy(manx,many,KHITO,YES):// こけた人
	beep():vwait(2)
	beep():vwait(2)
	if c=EDA then sc=sc-SCEDA else sc=sc-SCHUNE
	score()
	vwait(12)
	hito=HITO
	motimono=0:// 持ち物を落としてしまう
	return(hito)
endfunc

//*****************************************************************

func printScore(mes;str,sc;int)
	print mes;
//	if sc<0 then print "-"; else print "+";
	print using "+%%%%",sc
endfunc

func saiten()
// 祭典ではなく採点
int i
	for i=0 to 4
		beep():vwait(2)
	next
	//
	locate(21,7):prints(localizedString("終わり","End !!"))
	if sc>hsc then hsc=sc:// 最高記録
	if sc<wsc then wsc=sc:// 最低記録
	if isLocalizeJapan() then {
		locate((WX-15)/2,8)
		printScore("　　得点：",sc)
	} else {
		locate((WX-16)/2,8)
		printScore("Your Score:",sc)
	}
	if isLocalizeJapan() then {
		locate((WX-15)/2,9)
		printScore("最高得点：",hsc)
	} else {
		locate((WX-16)/2,9)
		printScore("High Score:",hsc)
	}

	if isLocalizeJapan() then {
		locate((WX-15)/2,10)
		printScore("最低得点：",wsc)
	} else {
		locate((WX-16)/2,10)
		printScore("WorstScore:",wsc)
	}
	// today()
endfunc

//*****************************************************************

func today()
	if fload then {
		if isLocalizeJapan() then {
			locate((WX-8)/2,11)
			print "(今まで)"
		} else {
			locate((WX-11)/2,11)
			print "(Up to now)"
		}
	} else {
		if isLocalizeJapan() then {
			locate((WX-6)/2,11)
			print "(今日)"
		} else {
			locate((WX-9)/2,11)
			print "(Today's)"
		}
	}
endfunc

//*****************************************************************

func move_momo(n;int)
// 桃の動き
	mx(n)=mx(n+1)+rand2(3)-1:// 左右に１つ動く可能性有り
	my(n)=my(n+1)+1
endfunc

//*****************************************************************

func move_man(mode;int)
// 人を動かす
int c,dx=0
	if mode then vwait(7)

	// キー入力
	c=inkey()
	if c=0 then return
	kbclr()
	
	// 移動
	if c=KLEFT  then dx=-1
	if c=KRIGHT then dx= 1
	if dx=0 then return:// 動かない
	
	// 移動出来る？：移動先判定
	switch scrn(manx+dx,many)
		case SPACE: // 移動先は空間＝移動可能
			printxy(manx,many,' ',NO):// 元の位置を消す
			manx=manx+dx
			printxy(manx,many,hito,YES):// 普通の人／桃を持った人
			return
		case KISI: // 移動先が岸のとき
			if hito<>HITO then { :// 何か持っている時
				hito=HITO
				printxy(manx,many,hito,NO):// 人をもとに戻す
				printxy(manx+dx,many,motimono,YES):// 持ち物をおろす
				beep():vwait(6)
				// 得点加算
				if motimono=MOMO then sc=sc+SCMOMO else sc=sc+SCSAKE
				score()
				motimono=0:// 持ち物を消す
				vwait(13)
				printxy(manx+dx,many,KISI,YES):// 岸を元に戻す
			}
	endswitch
	// それ以外の物がある時：動けない
endfunc

//*****************************************************************

func init()
// 初期化
	// 乱数初期化
	srand2()
	
	// 変数初期化
	sc=0		:// 得点
	mm=0		:// 消すべきものはない
	hito=HITO	:// 通常の人
	motimono=0	:// 何も持っていない
endfunc

//*****************************************************************

func disp_init()
// 画面初期化
	// 仮想テキストＶＲＡＭクリア
	init_tvram()
	cls()
	bitmapWipe()
	bitmapImgLoad()
	
	// 山と川
	make_river()
	
	// タイトル等表示
	title()
	locate(34,1):prints("TIME  00:00")
	//					+01234567890
endfunc

//*****************************************************************

func title()
// タイトル表示
	locate(0,0)
	prints(localizedString("＊＊　新説！？ 桃太郎ゲーム　＊＊","** New theory!? The game of Peach Boy **"))
	score()
endfunc

//*****************************************************************

func score()
// 得点表示
	//						  TIME  00:00
	locate(34,3):print using "Score #####";sc
endfunc

//*****************************************************************

func int time_print()
int tim
	tim=time()
	if tim-tm<>stime then {
		stime=stime+1
		locate(40,1):print using "%%:%%";stime\60,(stime mod 60)
	}
	return(stime>=TLIMIT)
endfunc

//*****************************************************************

func make_river()
// 山と川を描く
int i,x,y,ii
	// 景色
	printxys(0, 1,"]          []    []      []                     ",NO)
	printxys(0, 2," ]   []   [,,]  [  ]    [,,]                    ",NO)
	printxys(0, 3,"^ ] [||] [,,,,][ ^  ]  [,,,,]                   ",NO)
	printxys(0, 4," ^ ]    [,,,,,[ ^    ][......]     []           ",NO)
	printxys(0, 5,"^ ^ ]  [,,,,,[     ^  ]_......]   [  ]          ",NO)
	printxys(0, 6," | | ][.....[   ^      ]]......] [    ]         ",NO)
	printxys(0, 7,"| | | |||||[ ^       ^ [ ]&&&&&&]  . . ]___     ",NO)
	printxys(0, 8,"..... . . ||||||||||||[   ]^^^^^^]| | | | |]    ",NO)
	printxys(0, 9,"|||||||||||||||||||||[     ]^^^^^^]. . . . .]|||",NO)
	
	// 各流域の場所
	karyuu  =6			:// 最下行から６行分は下流域
	chuuryuu=karyuu+7	:// その上７行は中流域
	jouryuu =chuuryuu+7	:// さらにその上７行は上流域
	
	// 川
	mx(WKAWA+1)=24
	my(WKAWA+1)=9
	char c
	for i=0 to WKAWA:// 20行分の川
		y=10+i
		
		// 左側
		x=20-i
		// 木
		if i<WKAWA and rand2(4)=1 then {
			if rand2(10)<5 then c='|' else c='^'
			printxy(rand2(x),y,c,NO)
		}
		printxy(x,y,'[',NO)
		
		// 右側
		x=28+i
		printxy(x,y,']',NO)
		// 木
		if i<WKAWA and rand2(4)=1 then {
			if rand2(10)<5 then c='^' else c='|'
			printxy(x+1+rand2(WX-x-1),y,c,NO)
		}
		
		ii=WKAWA-i
		move_momo(ii)
		setmomo(ii)
	next
	// 岸辺
	printxy(x,y,KISI,NO)
	
	// 人表示
	manx=x-1
	many=y
	printxy(manx,many,HITO,YES)
endfunc

//****************************************************************
// 仮想VRAM / Virtual VRAM
//****************************************************************
// 今回は各パターンが重なることはない

func printxy2(x;int,y;int,c;char,fsoon;int)
// 仮想VRAMに書き込まずに表示する
	// スプライトとして定義しているパターンを読み出してグラフィックに描画する
	dim int ptrn(16*16)
	sp_pat(c,ptrn):// パターン読みだし
	bitmapPattern(gcx+x*16,gcy+y*16,16,16,ptrn)
	if fsoon then bitmapImgLoad():// 即時表示更新
endfunc

func printxy(x;int,y;int,c;char,fsoon;int)
	// 仮想VRAMに書き込む
	tvram(x,y)=c
	
	// 表示
	printxy2(x,y,c,fsoon)
endfunc

//*****************************************************************

func printxys(x;int,y;int,s;str,fsoon;int)
int i
	for i=0 to strlen(s)-1
		printxy(x,y,s[i],fsoon)
		x=x+1
		if x>=WX then x=0:y=y+1
		if y>=WY then y=WY-1
	next
endfunc

//*****************************************************************

func int scrn(x;int,y;int)
// 仮想テキストＶＲＡＭを読み出す / Read virtual VRAM
	return(tvram(x,y))
endfunc

//*****************************************************************

func init_tvram()
// 仮想テキストＶＲＡＭ初期化

int x,y
	for y=0 to WY-1
		for x=0 to WX-1
			tvram(x,y)=SPACE
		next
	next
endfunc

//****************************************************************
// 関数
//****************************************************************

// スプライト定義
func setSpriteWithColor(sptrn;str,no;int,col2;int)
	// (0)16進文字列→配列
	dim char fnt(16/8*16)
	hexstrToArray(sptrn,fnt)

	// (1)フォントパターンをiOS型スプライトパターンに変換
	//locate(0,1)
	dim int ptrn(16*16)
	int i,j
	int fk=0,sk=0,col
	for i=1 to 16/8*16
		char c=fnt(fk):fk=fk+1
	//	print right$("0"+hex$(c),2);",";
		for j=0 to 7
			col=0
			if (c and bit(7-j))<>0 then col=col2:// とりあえず今は単色展開のみ
			ptrn(sk)=col
			sk=sk+1
		next
	next
//	print
	// (2)スプライトに定義
	sp_def(no,ptrn)

	// (3)仮表示 for test
//	int x=no mod 32
//	int y=no/32
//	bitmapPattern(x*16,y*16+128,16,16,ptrn)
endfunc

func setSprite(sptrn;str,no;int)
	setSpriteWithColor(sptrn,no,&hffffffff)
endfunc

//****************************************************************
// キー入力
//****************************************************************

func setKeys(x;int,y;int)
	enum
		XC=3
		YC=1
		K1X=16*4
		K1Y=16*4
	endenum
	if touchallcnt =0 then {
		dim int keys( XC*YC-1)={KLEFT,FKEY_WAKUONLY,KRIGHT}
		dim str disps(XC*YC-1)={"←"," ","→"}
		touchallcnt =setTouchKeys(x*16,y*16,XC,YC,K1X,K1Y,keys,disps,"Migu-1M-Regular",touchNo)
	}
	// 登録個数を還す
	return (touchallcnt)
endfunc

func removeKeys()
// 全タッチアリアの解除 / release all key touch area
	if touchallcnt>0 then {
		resetAllTouchKeys(touchNo,touchallcnt)
		touchallcnt =0:// 登録してないの印
	}:// すでに解除済みの時は何もしない / if already released, do nothing.
endfunc

//****************************************************************
